//--------------------------------------------------
//EMP Credit The_force modified by REDmosquito to set energy rate properly.
//--------------------------------------------------

// the sounds
datablock AudioProfile(EMPStartSound)
{
filename = "fx/explosions/grenade_flash_explode.wav";
description = AudioClosest3d;
preload = true;
};

datablock AudioProfile(EMPEndSound)
{
filename = "fx/vehicles/inventory_pad_on.wav";
description = AudioClosest3d;
preload = true;
};

// the shock effect
datablock ShockLanceProjectileData(ZapFX)
{
   directDamage        = 0;
   radiusDamageType    = $DamageType::Default;
   kickBackStrength    = 0;
   velInheritFactor    = 0;
   sound               = "";

   zapDuration = 1.0;
   impulse = 0;
   boltLength = 14.0;
   extension = 14.0;            // script variable indicating distance you can shock people from
   lightningFreq = 50.0;
   lightningDensity = 18.0;
   lightningAmp = 0.25;
   lightningWidth = 0.05;


   boltSpeed[0] = 2.0;
   boltSpeed[1] = -0.5;

   texWrap[0] = 1.5;
   texWrap[1] = 1.5;

   startWidth[0] = 0.3;
   endWidth[0] = 0.6;
   startWidth[1] = 0.3;
   endWidth[1] = 0.6;

   texture[0] = "special/shockLightning01";
   texture[1] = "special/shockLightning02";
   texture[2] = "special/shockLightning03";
   texture[3] = "special/ELFBeam";
};

function zapObject(%obj)
{
   %obj.zap = new ShockLanceProjectile()
     {
          dataBlock        = "ZapFX";
          initialDirection = "0 0 0";
          initialPosition  = %obj.getWorldBoxCenter();
          sourceObject     = %obj;
          sourceSlot       = 0;
          targetId         = %obj;
     };
     MissionCleanup.add(%obj.zap);

}

function ShapeBase::zapObject(%obj)
{
     zapObject(%obj);
}

// the magic function
function empOff(%obj, %oldRecharge) //new EMP function
{

if (%obj.EMPCounter == 0)
{
    %obj.setRechargeRate(%oldRecharge);
    %obj.playAudio(0, EMPEndSound);
    messageClient(%obj.client, 'msgClient', "Power back online.");
    %obj.isEMP = false;
}
else
{
    %obj.EMPCounter--;
    %obj.zapObject();//shock
    schedule(1000, %obj, "empOff", %obj, %oldRecharge);
    %obj.setWhiteout(0.3);
}

}

function EMPObject(%obj)
{
  if(%obj.getArmorSize(%obj) $= "Recon")
  return;
  if(%obj.EMPCounter > 1)
  {
  if(%obj.EMPCounter > 30)
  return;

  %obj.EMPCounter += 15;
  if(1)//isPlayer(%obj))
  {
  messageClient(%obj.client, 'msgMoreEMP', '\c2You have taken more EMP damage.');
  }
  return;
  }
  else
  {
  %obj.setEnergyLevel(0);
  %oldRecharge = %obj.getRechargeRate();//modified, dont call armor datablock-RED
  %obj.setRechargeRate(0);
  %obj.EMPCounter = 15;
  %obj.zapObject();//shock
  if(1)//isPlayer(%obj))
  {
  %obj.setWhiteout(0.3);
  %obj.playAudio(0, EMPStartSound);
  messageClient(%obj.client, 'msgEMP', "You were hit with an EMP, power of-line.");
  }
  schedule(1000, %obj, "empOff", %obj, %oldRecharge);
  }
}

function ShapeBase::EMPObject(%obj)
{
     EMPObject(%obj);
}